/* GemRB - Infinity Engine Emulator
 * Copyright (C) 2003 The GemRB Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * $Id: OpcodeMgr.h 6005 2009-05-19 10:21:38Z lynxlupodian $
 *
 */

/**
 * @file OpcodeMgr.h
 * Declares OpcodeMgr, abstract parent for plugins registering new opcodes
 * @author The GemRB Project
 */

#include "Plugin.h"

#ifndef OPCODEMGR_H
#define OPCODEMGR_H

#ifdef WIN32

#ifdef GEM_BUILD_DLL
#define GEM_EXPORT __declspec(dllexport)
#else
#define GEM_EXPORT __declspec(dllimport)
#endif

#else
#define GEM_EXPORT
#endif

/**
 * @class OpcodeMgr
 * Abstract parent for plugins registering new opcodes
 */

class GEM_EXPORT OpcodeMgr : public Plugin {
public:
	OpcodeMgr(void);
	virtual ~OpcodeMgr(void);
};

#endif  // !OPCODEMGR_H
